/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the Example resource file.
***************************************************************/

/* c2f.bbR.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/BulletinB.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, button, bb, label, scale;

void buttonCB(Widget w,
    int client_data,
    XmPushButtonCallbackStruct *call_data)
/* handles the pushbutton's activate callback. */
{
    exit(0);
}

void scaleCB(Widget w,
    int client_data,
    XmScaleCallbackStruct *call_data)
/* handles the pushbutton's activate callback. */
{
    char s[100];
    Arg al[10];
    int ac;

    sprintf(s,"farenheit=%d",call_data->value*9/5+32);
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate(s,char_set)); ac++;
    XtSetValues(label,al,ac);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel=XtAppInitialize(&context,"Example",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* create a bulletin board to hold the three widgets */
    bb=XmCreateBulletinBoard(toplevel,"bb",NULL,0);
    XtManageChild(bb);

    /* create a push button */
    button=XmCreatePushButton(bb,"button",NULL,0);
    XtManageChild(button);
    XtAddCallback(button,XmNactivateCallback,buttonCB,NULL);

    /* create a scale */
    scale=XmCreateScale(bb,"scale",NULL,0);
    XtManageChild(scale);
    XtAddCallback(scale,XmNdragCallback,scaleCB,NULL);

    /* create a label */
    label=XmCreateLabel(bb,"label",NULL,0);
    XtManageChild(label);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
