/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the drawing of a bitmap in a drawing
area.
***************************************************************/

/* bitmap.c */

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>
#include "folder.xbm"

XtAppContext context;

GC gc;
Widget drawing_area;
Widget toplevel;

unsigned int get_depth(w)
    Widget w;
/* gets the depth of the display holding w. */
{
    Window r;
    unsigned int x,y,wd,ht,bw,depth;

    XGetGeometry(XtDisplay(w),XtWindow(w),
        &r,&x,&y,&wd,&ht,&bw,&depth);
    return depth;
}

void setup_gc()
/* set up the graphics context. */
{
    int foreground,background;
    XGCValues vals;
    Arg al[10];
    int ac;

     /* get the current fg and bg colors. */
    ac=0;
    XtSetArg(al[ac], XmNforeground, &foreground); ac++;
    XtSetArg(al[ac], XmNbackground, &background); ac++;
    XtGetValues(drawing_area, al, ac);

    /* create the gc. */
    vals.foreground = foreground;
    vals.background = background;
    gc=XtGetGC(drawing_area, GCForeground | GCBackground ,&vals);
}

void draw_icon(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Pixmap p;
    int fc,bc,depth;
    Arg al[10];
    int ac;

    /* get the current fg and bg colors. */
    ac=0;
    XtSetArg(al[ac], XmNforeground, &fc); ac++;
    XtSetArg(al[ac], XmNbackground, &bc); ac++;
    XtGetValues(drawing_area, al, ac);

    depth=get_depth(drawing_area);

    p=XCreatePixmapFromBitmapData(XtDisplay(drawing_area), 
        XtWindow(drawing_area),folder_bits,folder_width,folder_height,
        fc, bc, depth);
    XCopyArea(XtDisplay(drawing_area),p,XtWindow(drawing_area),gc,0,0,
        folder_width, folder_height, 100,100 );
    XFreePixmap(XtDisplay(drawing_area),p);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
      Arg al[10];
      int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* set window size. */
    ac=0;
    XtSetArg(al[ac],XmNheight,200); ac++;
    XtSetArg(al[ac],XmNwidth,200); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a drawing area widget. */
    ac=0;
    drawing_area=XmCreateDrawingArea(toplevel,"drawing_area",al,ac);
    XtManageChild(drawing_area);    
    XtAddCallback(drawing_area,XmNexposeCallback,draw_icon,NULL);

    setup_gc();

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
